/*
Copyright (c) 2018 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/

define(['baja!',
  'nmodule/webEditors/rc/fe/baja/StatusValueEditor',
  'bajaux/mixin/subscriberMixIn',
  'jquery',
  'Promise',
  'bajaux/util/SaveCommand'],
  function (      //NOSONAR
    baja,
    StatusValueEditor,
    subscriberMixin,
    $,
    Promise,     //NOSONAR
    SaveCommand) {

    /**
    * Editor that will not allow to change the IN_ONLY slot value
    */

    var SylkParamOutSlotWidget = function () {
      StatusValueEditor.apply(this, arguments);    //NOSONAR
      subscriberMixin(this);
      this.getCommandGroup().add(new SaveCommand());
    };

    //extend and set up prototype chain
    SylkParamOutSlotWidget.prototype = Object.create(StatusValueEditor.prototype);
    SylkParamOutSlotWidget.prototype.constructor = SylkParamOutSlotWidget;

    SylkParamOutSlotWidget.prototype.doInitialize = function (dom) {
      StatusValueEditor.prototype.doInitialize.call(this, dom);
    };
    
    SylkParamOutSlotWidget.prototype.doLoad = function (comp) {
      var that = this;
      return StatusValueEditor.prototype.doLoad.call(this, comp).then(function(){
        comp.getParent().rpc("getUnitsFromSylkOut").then(function(val){
          if(val!== undefined){
            that.$getDisplayEditor().load(comp.toString() + " " + val);
          }
        });
      });
    };

    return SylkParamOutSlotWidget;
  });
